/*------------------------------------------------------------
 we start with some definitions required by every program
 do not modify them, add own code below!
------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 to generate only the C code, run:
 valac -C --pkg gtk+-2.0 --pkg libglade-2.0 --pkg gmodule-2.0 main.gs 

-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 to compile in wine:
 wine start compile-win.bat

-----------------------------------------------------------------------------*/

[indent=2]
uses
  Gtk

xml : Glade.XML


//-- this is needed for every program using libglade --

def connect_signals (handler_name : string, object : GLib.Object, signal_name : string ,signal_data : string? , connect_object : GLib.Object?, after : bool)
  var module = Module.open (null, ModuleFlags.BIND_LAZY)
  sym : void*

  if (module.symbol (handler_name, out sym))
    Signal.connect (object, signal_name, (GLib.Callback) sym, null)

//-- HELPER method: this method returns a WIDGET ! --

def get_widget(name : string) : Widget
  var w = xml.get_widget(name)
  return w

//-- HELPER method: this method returns a BUTTON ! --
def get_button(name : GLib.Object) : Button
  b : Button*
  b = name
  return b


//-- HELPER method: this method returns a COMBOBOX ! --
def get_combobox(name : GLib.Object) : ComboBox
  b : ComboBox*
  b = name
  return b

//-- HELPER methods to run executables/commands


def exec(thecmd : string)
  Process.spawn_command_line_async(thecmd)

def run(thecmd : string) : string
  ret_stdout:string
  ret_stderr:string
  ret_status:int
  Process.spawn_command_line_sync(thecmd,out ret_stdout,out ret_stderr,out ret_status)
  return ret_stdout

/*----------------------------------------------------------------------
 here the signal handlers for the elements of a window are defined --
 add your own signalhandlers here!
----------------------------------------------------------------------*/
 
def on_button1_clicked (widget : Button)

  var cmd = ""
  var tempdir = Environment.get_tmp_dir ()
  //print("%s" , tempdir)

  var chosen = ""
  chosen = get_combobox(get_widget("combobox1")).get_active_text()

  cmd = "regedit regs/"
  if tempdir.contains("\\")
    cmd = "C:/windows/regedit.exe regs/"
  
  cmd = cmd.concat(chosen)
  cmd = cmd.concat(".reg")
  //print("%s" , cmd)
  run(cmd)

  
def on_button2_clicked (widget : Widget)

  var cmd = ""
  var tempdir = Environment.get_tmp_dir ()
  
  if tempdir.contains("\\")
    exec("z:/usr/bin/winecfg")
    return
  
  exec("winecfg")


def on_window1_destroy (widget : Widget)

  Gtk.main_quit ()




/*-----------------
 main program
-----------------*/
init


  Gtk.init (ref args)
  xml = new Glade.XML ("project.glade", null, null)
  xml.signal_autoconnect_full (connect_signals)

  //-- read in a directory, add matching entries to the combobox
  //-- note: the combo must have one dummy entry already
  var check = ""
  mydir : Dir  
  mydir = Dir.open ("regs");
  filename : string
  while (filename = mydir.read_name ()) != null
    //print ("---%s" , filename)
    if filename.length > 4
      check = filename.substring(filename.length-4,4)
      //print ("----%s" , check)
      if check is ".reg"
        //print ("-ok---%s" , check)
        get_combobox(get_widget("combobox1")).append_text(filename.substring(0,filename.length-4))
  
  //-- remove the first dummy entry from the combo
  get_combobox(get_widget("combobox1")).remove_text(0)
  get_combobox(get_widget("combobox1")).set_active(0)

  Gtk.main ()
    
    